package betterwithmods.api.tile.multiblock;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTUtil;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.common.capabilities.Capability;

import javax.annotation.Nullable;

public class TileEntityProxyBlock extends TileEntity {
    private BlockPos controller;

    public BlockPos getController() {
        return controller;
    }

    public void setController(BlockPos controller) {
        this.controller = controller;
        this.func_70296_d();
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        NBTTagCompound compound = super.func_189515_b(tag);
        if (controller != null) compound.func_74782_a("controller", NBTUtil.func_186859_a(controller));
        return compound;
    }

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);
        if (tag.func_74764_b("controller")) controller = NBTUtil.func_186861_c(tag.func_74775_l("controller"));
    }

    public void notifyControllerOnBreak() {
        if (controller != null && this.field_145850_b.func_175625_s(controller) instanceof TileEntityMultiblock) {
            ((TileEntityMultiblock) this.field_145850_b.func_175625_s(controller)).destroyMultiblock();
        }
    }

    @Override
    public boolean hasCapability(Capability<?> capability, @Nullable EnumFacing facing) {
        if (controller != null && this.field_145850_b.func_175625_s(controller) instanceof IExternalCapability)
            return ((IExternalCapability) this.field_145850_b.func_175625_s(controller)).hasExternalCapability(field_174879_c, capability, facing);
        return super.hasCapability(capability, facing);
    }

    @Override
    public <T> T getCapability(Capability<T> capability, @Nullable EnumFacing facing) {
        if (controller != null && this.field_145850_b.func_175625_s(controller) instanceof IExternalCapability)
            return ((IExternalCapability) this.field_145850_b.func_175625_s(controller)).getExternalCapability(field_174879_c, capability, facing);
        return super.getCapability(capability, facing);
    }
}
