package betterwithmods.client.render;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.entity.EntityExtendingRope;
import betterwithmods.util.AABBArray;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.*;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.entity.Entity;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

/**
 * @author mrebhan
 */

public class RenderExtendingRope extends Render<EntityExtendingRope> {

    public RenderExtendingRope(RenderManager renderManagerIn) {
        super(renderManagerIn);
    }

    @Override
    protected ResourceLocation func_110775_a(EntityExtendingRope entity) {
        return null;
    }

    @Override
    public void func_76986_a(EntityExtendingRope entity, double x, double y, double z, float entityYaw,
                         float partialTicks) {
        World world = entity.func_130014_f_();
        IBlockState iblockstate = BWMBlocks.ROPE.func_176223_P();
        this.func_110776_a(TextureMap.field_110575_b);
        GlStateManager.func_179094_E();
        GlStateManager.func_179140_f();
        Tessellator tessellator = Tessellator.func_178181_a();
        BufferBuilder vertexbuffer = tessellator.func_178180_c();

        vertexbuffer.func_181668_a(7, DefaultVertexFormats.field_176600_a);
        BlockPos blockpos = new BlockPos(0, entity.func_174813_aQ().field_72337_e, 0);
        GlStateManager.func_179137_b(x - 0.5, (float) (y - (double) blockpos.func_177956_o()), z - 0.5);
        GlStateManager.func_179137_b(-0.005, 0, -0.005);
        BlockRendererDispatcher blockrendererdispatcher = Minecraft.func_71410_x().func_175602_ab();

        int i = 0;
        while (entity.getPulleyPosition().func_177956_o() - entity.field_70163_u > i && i < 2) {
            blockrendererdispatcher.func_175019_b().func_187493_a(world,
                    blockrendererdispatcher.func_184389_a(iblockstate), iblockstate, blockpos.func_177981_b(i), vertexbuffer,
                    false, 0);
            i++;
        }

        entity.getBlocks().forEach((vec, state) -> blockrendererdispatcher.func_175019_b().func_187493_a(world,
                blockrendererdispatcher.func_184389_a(state), state, blockpos.func_177971_a(vec), vertexbuffer, false, 0));

        tessellator.func_78381_a();

        GlStateManager.func_179145_e();
        GlStateManager.func_179121_F();

        if (field_76990_c.func_178634_b()) {
            renderDebugBoundingBox(entity, x, y, z, entityYaw, partialTicks);
        }

        super.func_76986_a(entity, x, y, z, entityYaw, partialTicks);
    }

    private void renderDebugBoundingBox(Entity entityIn, double x, double y, double z, float entityYaw,
                                        float partialTicks) {
        GlStateManager.func_179132_a(false);
        GlStateManager.func_179090_x();
        GlStateManager.func_179140_f();
        GlStateManager.func_179129_p();
        GlStateManager.func_179084_k();
        AxisAlignedBB axisalignedbb = entityIn.func_174813_aQ();
        for (AxisAlignedBB aabb : AABBArray.getParts(axisalignedbb)) {
            RenderGlobal.func_189694_a(aabb.field_72340_a - entityIn.field_70165_t + x, aabb.field_72338_b - entityIn.field_70163_u + y,
                    aabb.field_72339_c - entityIn.field_70161_v + z, aabb.field_72336_d - entityIn.field_70165_t + x, aabb.field_72337_e - entityIn.field_70163_u + y,
                    aabb.field_72334_f - entityIn.field_70161_v + z, 0.5F, 0.5F, 1.0F, 1.0F);
        }

        GlStateManager.func_179098_w();
        GlStateManager.func_179145_e();
        GlStateManager.func_179089_o();
        GlStateManager.func_179084_k();
        GlStateManager.func_179132_a(true);
    }

}
