package betterwithmods.common.world.gen.village;

import betterwithmods.module.hardcore.HCVillages;
import net.minecraft.block.BlockLadder;
import net.minecraft.block.BlockStairs;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.World;
import net.minecraft.world.gen.structure.StructureBoundingBox;
import net.minecraft.world.gen.structure.StructureComponent;
import net.minecraft.world.gen.structure.StructureVillagePieces;

import java.util.List;
import java.util.Random;

/**
 * Created by tyler on 5/25/17.
 */
public class Hut2 extends AbandonedVillagePiece {

    public Hut2() {
    }

    public Hut2(StructureVillagePieces.Start start, int p_i45566_2_, Random rand, StructureBoundingBox p_i45566_4_, EnumFacing facing) {
        super(start, p_i45566_2_);
        this.func_186164_a(facing);
        this.field_74887_e = p_i45566_4_;
    }


    public boolean func_74875_a(World worldIn, Random randomIn, StructureBoundingBox structureBoundingBoxIn) {
        if (this.field_143015_k < 0) {
            this.field_143015_k = this.func_74889_b(worldIn, structureBoundingBoxIn);

            if (this.field_143015_k < 0) {
                return true;
            }

            this.field_74887_e.func_78886_a(0, this.field_143015_k - this.field_74887_e.field_78894_e + 6 - 1, 0);
        }

        IBlockState iblockstate = this.func_175847_a(Blocks.field_150347_e.func_176223_P());
        IBlockState iblockstate1 = this.func_175847_a(Blocks.field_150344_f.func_176223_P());
        IBlockState iblockstate2 = this.func_175847_a(Blocks.field_150446_ar.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.NORTH));
        IBlockState iblockstate3 = this.func_175847_a(Blocks.field_150364_r.func_176223_P());
        IBlockState iblockstate4 = this.func_175847_a(Blocks.field_180407_aO.func_176223_P());
        IBlockState iblockstate5 = Blocks.field_150468_ap.func_176223_P().func_177226_a(BlockLadder.field_176382_a, EnumFacing.SOUTH);
        if (HCVillages.disableAllComplexBlocks) {
            iblockstate2 = iblockstate;
            iblockstate4 = Blocks.field_150350_a.func_176223_P();
            iblockstate5 = Blocks.field_150350_a.func_176223_P();
        }
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 0, 0, 4, 0, 4, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 4, 0, 4, 4, 4, iblockstate3, iblockstate3, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 4, 1, 3, 4, 3, iblockstate1, iblockstate1, false);
        this.func_175811_a(worldIn, iblockstate, 0, 1, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 0, 2, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 0, 3, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 4, 1, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 4, 2, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 4, 3, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 0, 1, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 0, 2, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 0, 3, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 4, 1, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 4, 2, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate, 4, 3, 4, structureBoundingBoxIn);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 1, 1, 0, 3, 3, iblockstate1, iblockstate1, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 4, 1, 1, 4, 3, 3, iblockstate1, iblockstate1, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 1, 4, 3, 3, 4, iblockstate1, iblockstate1, false);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 0, 2, 2, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 2, 2, 4, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.GLASS_PANE.getDefaultState(), 4, 2, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 0, 2, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 2, 2, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 4, 2, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 1, 1, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 1, 2, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 1, 3, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 2, 3, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 3, 3, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 3, 2, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 3, 1, 0, structureBoundingBoxIn);

        if (this.func_175807_a(worldIn, 2, 0, -1, structureBoundingBoxIn).func_185904_a() == Material.field_151579_a && this.func_175807_a(worldIn, 2, -1, -1, structureBoundingBoxIn).func_185904_a() != Material.field_151579_a) {
            this.func_175811_a(worldIn, iblockstate2, 2, 0, -1, structureBoundingBoxIn);

            if (this.func_175807_a(worldIn, 2, -1, -1, structureBoundingBoxIn).func_177230_c() == Blocks.field_185774_da) {
                this.func_175811_a(worldIn, Blocks.field_150349_c.func_176223_P(), 2, -1, -1, structureBoundingBoxIn);
            }
        }

        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 1, 1, 3, 3, 3, Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), false);


        this.func_175811_a(worldIn, iblockstate4, 0, 5, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 1, 5, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 2, 5, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 3, 5, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 4, 5, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 0, 5, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 1, 5, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 2, 5, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 3, 5, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 4, 5, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 4, 5, 1, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 4, 5, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 4, 5, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 0, 5, 1, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 0, 5, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 0, 5, 3, structureBoundingBoxIn);

        this.func_175811_a(worldIn, iblockstate5, 3, 1, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 3, 2, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 3, 3, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 3, 4, 3, structureBoundingBoxIn);


        this.func_189926_a(worldIn, EnumFacing.NORTH, 2, 3, 1, structureBoundingBoxIn);

        for (int j = 0; j < 5; ++j) {
            for (int i = 0; i < 5; ++i) {
                this.func_74871_b(worldIn, i, 6, j, structureBoundingBoxIn);
                this.func_175808_b(worldIn, iblockstate, i, -1, j, structureBoundingBoxIn);
            }
        }

        this.func_74893_a(worldIn, structureBoundingBoxIn, 1, 1, 2, 1);
        return true;
    }

    @Override
    public StructureVillagePieces.PieceWeight getVillagePieceWeight(Random random, int size) {
        return new StructureVillagePieces.PieceWeight(Hut2.class, 4, MathHelper.func_76136_a(random, 2 + size, 4 + size * 2));
    }

    @Override
    public Class<?> getComponentClass() {
        return Hut2.class;
    }

    @Override
    public StructureVillagePieces.Village buildComponent(StructureVillagePieces.PieceWeight villagePiece, StructureVillagePieces.Start startPiece, List<StructureComponent> pieces, Random random, int p1, int p2, int p3, EnumFacing facing, int p5) {
        StructureBoundingBox structureboundingbox = StructureBoundingBox.func_175897_a(p1, p2, p3, 0, 0, 0, 5, 6, 5, facing);
        return StructureComponent.func_74883_a(pieces, structureboundingbox) != null ? null : new Hut2(startPiece, p5, random, structureboundingbox, facing);
    }
}
